// -------------------------------------------------------------------------------
// 
// 		cwCu		ʐMvOwb_t@C
// 
// 				Ver 3.13f
// 
// -------------------------------------------------------------------------------

#ifndef __DXNETWORK_H__
#define __DXNETWORK_H__

#include "DxCompileConfig.h"

#ifndef DX_NON_NETWORK

// CN[h ------------------------------------------------------------------
#include "DxLib.h"
#include "DxHandle.h"
#include "DxRingBuffer.h"
#include "DxThread.h"
#include "DxFile.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

#define MAX_HTTPHANDLE_NUM			(100)				// Ɏgpł HTTP nh̐

// HTTP ̏Ԉꗗ
enum HTTP_STATE
{
	HTTP_ST_CONNECT = 0,				// ڑ
	HTTP_ST_GET = 1,					// GET Ńt@CM
	HTTP_ST_HEAD = 2,					// HEAD Ńwb_M
	HTTP_ST_POST = 3,					// POST ŎɂbfhȂǂo͎M
} ;

// HTTP ̏ꗗ
enum HTTP_PROC
{
	HTTP_PR_GET,						// GET Ńt@C擾
	HTTP_PR_POST,						// POST Ńt@C擾
	HTTP_PR_HEAD,						// HEAD Ńwb_擾
} ;

// ۑꗗ
enum HTTP_SAVEPLACE
{
	HTTP_SV_FILE = 0,					// ۑ̓t@C
	HTTP_SV_MEM = 1,					// ۑ̓
} ;

// FTP ̏Ԉꗗ
enum FTP_STATE
{
	FTP_ST_CONNECT = 0,					// ڑ
	FTP_ST_LOGIN_NAME = 1,				// OC([U[l[͒)
	FTP_ST_LOGIN_PASS = 2,				// OC(pX[h͒)
	FTP_ST_TYPE_A = 3,					// TYPE A M
	FTP_ST_TYPE_B = 4,					// TYPE B M
	FTP_ST_SIZE = 5,					// TCY擾
	FTP_ST_QUIT = 6,					// I
	FTP_ST_PASV = 7,					// Passive [hȍ~
	FTP_ST_RETR = 8,					// 擾t@C𑗐M
	FTP_ST_STOR = 9,					// Mt@C𑗐M
	FTP_ST_DATA_GET = 10,				// f[^M
	FTP_ST_DATA_SET = 11,				// f[^M
	FTP_ST_CWD = 12,					// fBNgύX
} ;

// FTP ̏ꗗ
enum FTP_PROC
{
	FTP_PR_LOGIN = 0,					// OC
	FTP_PR_IDLE = 1,					// ҋ@
	FTP_PR_CHDIR = 2,					// fBNgύX
	FTP_PR_FILE_SET = 3,				// t@CM
	FTP_PR_FILE_GET = 4,				// t@C擾
} ;

// \̒` --------------------------------------------------------------------

// WinSock2.0 Ŏgp`ƍ\

struct _addrinfo
{
	int						ai_flags ;							// AI_PASSIVE, AI_CANONNAME, AI_NUMERICHOST
	int						ai_family ;							// PF_xxx
	int						ai_socktype ;						// SOCK_xxx
	int						ai_protocol ;						// 0 or IPPROTO_xxx for IPv4 and IPv6
	size_t					ai_addrlen ;						// Length of ai_addr
	char					*ai_canonname ;						// Canonical name for nodename
	struct sockaddr			*ai_addr ;							// Binary address
	struct _addrinfo		*ai_next ;							// Next structure in linked list
} ;

struct _sockaddr_in6 
{
	short					sin6_family ;						// AF_INET6
	unsigned short			sin6_port ;							// Transport level port number
	unsigned long			sin6_flowinfo ;						// IPv6 flow information
	IPDATA_IPv6				sin6_addr ;							// IPv6 address
	unsigned long			sin6_scope_id ;						// set of interfaces for a scope
} ;

// ConnectNetWorkBase ŎgpO[of[^Z߂
struct CONNECTNETWORK_GPARAM
{
	int						NonUseDXProtocolFlag ;				// cwCũvgRgpȂǂ̃tO
	int						NonCloseAfterLostFlag ;				// ڑ؂ꂽɎIɃnhȂǂ̃tO( TRUE:ɉ͂Ȃ  FALSE:ɉ )
} ;

// \PbgP̃f[^\
struct SOCKETDATA
{
	HANDLEINFO				HandleInfo ;						// nhʃf[^

	int						IsUDP ;								// tcoڑǂ
	int						UseFlag ;							// f[^gpAtO
	int						IsIPv6 ;							// IPv6gpĂ邩ǂ

	int						ErrorFlag ;							// dȃG[tO( TRUE:  FALSE:ĂȂ )
	int						PreConnectionFlag ;					// ڑOtO( TRUE:ڑO  FALSE:ڑ )
	int						ConnectionFlag ;					// ڑĂ邩tO( TRUE:Ă  FALSE:ĂȂ )
	int						ConnectionLostFlag ;				// Cu[U[ؒfmFtOAAcceptedFlag FALSE ̎̂ݗL( TRUE:  FALSE:ĂȂ )
	int						AccepteConfirFlag ;					// Cu[U[ڑmFtO( TRUE:  FALSE:ĂȂ )
	int						AcceptFlag ;						// ڑꂽ̂ÂAtO( TRUE:ꂽ  FALSE: )

	int						DXProtocolFlag  ;					// cwCũvgRŒʐM邩ǂ̃tO( TRUE:TCYwb_t FALSE:WinSock̂܂܎g )
	int						CloseAfterLostFlag ;				// ؒfɃnh邩ǂ̃tO( TRUE:ɉ  FALSE:[U[ CloseNetWork ܂ŉȂ )

//	int						ID ;								// G[`FbNphc
	SOCKET					Socket ;							// \Pbgʔԍ

	int						RecvComDataVol ;					// obt@ɂvrobt@̓eׂēȂꍇAǂ܂ȂĂ͂ȂȂce
	RINGBUF					RecvBufferToUserR ;					// Cup҂ɌJMf[^̃Oobt@
	int						RecvComDataOriginalVol ;			// x̎MőMĂf[^eʁARecvComDataVol  0 ɂȂ RecvBufferToUserOpenSize ɉZ
	int						RecvBufferToUserOpenSize ;			// Cup҂ɌJMf[^̃TCY

	RINGBUF					SendBufferR ;						// Mobt@pOf[^
	int						SendComDataVol ;					// xɑMłȂꍇ̎cf[^
	int						SendComDataComVol ;					// xɑMf[^ʂ̑MxɑMłȂꍇ̎ce

	IPDATA					AcceptedIP ;						// ڑ̂ho(ؒfL)
	IPDATA_IPv6				AcceptedIP_IPv6 ;					// ڑ̂ho(ؒfL)
	unsigned int			Port ;								// ڑ̃|[g

	int						UDPReadFlag ;						// Mf[^݂邩AtO( TRUE:݂  FALSE:Ȃ )
	int						UDPWriteFlag ;						// f[^M\ȏԂAtO( TRUE:\  FALSE:s\ )

//	HANDLELIST				List ;								// Xgpf[^
} ;

// Winsockets֌W\
struct WINSOCKDATA
{
	int						ListenHandle ;						// ڑ҂pnh
/*
	SOCKETDATA				*CSocket[ MAX_SOCKET_NUM + 1 ] ;	// RlNgp\Pbgf[^
	HANDLELIST				SocketListFirst ;					// \PbgXg̐擪
	HANDLELIST				SocketListLast ;					// \PbgXg̏I[
*/
//	int						SocketNum ;							// \Pbg̐
//	int						HandleID ;							// nhɊ蓖Ăhc
	int						InitializeFlag ;					// tO
//	int						MaxSockets ;						// őڑ
	int						MyIPNum ;							// ̂hoAhX̐
	IPDATA					*MyIP ;								// ̂hoAhX
	int						TimeOutWait ;						// ^CAEg܂ł̎(~bP)
	HWND					ParentWindow ;						// eEChE
	HWND					MessageWindow ;						// EChEnh
	int						NonUseDXProtocolFlag ;				// cwCũvgRgpȂǂ̃tO
	int						NonCloseAfterLostFlag ;				// ڑ؂ꂽɎIɃnhȂǂ̃tO( TRUE:ɉ͂Ȃ  FALSE:ɉ )
	int						DestroyFlag ;						// bZ[WEChE WM_DESTROY 󂯂ǂ̃tO

//	DX_CRITICAL_SECTION		CriticalSection ;					// f[^ANZXpNeBJZNV

	HANDLE					ProcessNetMessageThreadHandle ;		// ProcessNetMessage ЂĂтÂvZX̃nh
	DWORD					ProcessNetMessageThreadID ;			// ProcessNetMessage ЂĂтÂvZX̂hc
	DWORD					ProcessNetMessageThreadExitFlag ;	// ProcessNetMessage ЂĂтÂvZXIɗĂtO
	DWORD					ProcessNetMessageThreadEndRequest ;	// ProcessNetMessage ЂĂтÂvZX̏INGXgtO
} ;

// HTTPʐM֌W\
struct HTTPDATA
{
	HTTP_PROC				Process ;							// 
	HTTP_STATE				State ;								// 
	int						Step ;								// ڏ
	int 					Counter ;							// ėpJE^
	int						Result ;							// 
	int						Error ;								// G[̏ꍇ̃G[e

	int						NetHandle ;							// HTTPT[oƂ̒ʐMɎgplbg[Nnh

	HTTP_SAVEPLACE			SavePlace ;							// ۑꏊ
	HANDLE					FilePoint ;							// M悪t@C̎Ɏgpt@C|C^
	void					**BufferPoint ;						// M悪̎Ɏgp|C^̃|C^

	int						FileSize ;							// t@CTCY
	int						RecvFileSize ;						// Mf[^̃TCY
	char					FileName[128] ;						// Mt@C
	
	char					Host[128] ;							// ڑ̃zXg
	char 					Path[256] ;							// Mt@C̃zXg̃pX
	char					*Param ;							// POST \bhŒp[^nۂ̕񂪊i[Ă|C^
	int						ParamLength ;						// p[^̒
	IPDATA					HostIP ;							// ڑzXĝho
	int						Port ;								// ڑ|[g
} ;

// HTTP ֌WǗf[^
struct HTTPSYS
{
	HTTPDATA				*Data[MAX_HTTPHANDLE_NUM] ;			// pf[^ւ̃|C^̔z
	int						Num ;								// pf[^̐

	int						UseProxy ;							// vLVgp邩ǂ
	char					ProxyHost[256] ;					// vLṼzXg
	int						ProxyPort ;							// vLṼ|[g
//	int						NonUseIEProxy ;						// hd̃vLVT[o[ݒgpȂǂ̃tO
} ;

// FTPʐM֌W\
struct FTPDATA
{
	int						UseFlag ;							// gptO
	
	FTP_PROC				Process ;							// 
	FTP_STATE				State ;								// 

	int						ComNetHandle ;						// R}h̑MɎgplbg[Nnh
	int						DatNetHandle ;						// f[^̑MɎgplbg[Nnh

	DWORD					Fp ;								// MɎgpt@C|C^
	int						FileSize ;							// t@CTCY
	int						FilePoint ;							// Mt@C̃TCY
	char					FileName[FILEPATH_MAX] ;			// Mt@C
	char					FileDir[FILEPATH_MAX] ;				// Mt@C݂pX
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

extern WINSOCKDATA SockData ;									// vrf[^
extern HTTPSYS HttpData ;										// HTTP ֌Wpf[^

// ֐vg^Cv錾-----------------------------------------------------------

extern 	int			InitializeNetWork( HWND WindowHandle = NULL ) ;							// ʐM@\
extern 	int			TerminateNetWork( void ) ;												// ʐM@\I

extern	int			WinSockProc( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam ) ;	// vrbZ[W̃R[obN֐

extern	int			AcceptNetWork( void ) ;													// ANZvg

extern	int			InitializeNetworkHandle( HANDLEINFO *HandleInfo ) ;						// lbg[Nnh
extern	int			TerminateNetworkHandle( HANDLEINFO *HandleInfo ) ;						// lbg[Nnȟns

extern	void		InitConnectNetWorkBaseGParam( CONNECTNETWORK_GPARAM *GParam ) ;			// CONNECTNETWORK_GPARAM 
extern	int			ConnectNetWorkBase_UseGParam( CONNECTNETWORK_GPARAM *GParam, IPDATA *IPData_IPv4, IPDATA_IPv6 *IPData_IPv6, int Port, int ASync, int ASyncLoadFlag = FALSE ) ;		// ConnectNetWorkBase ̃O[of[^ɃANZXȂ
extern	int			NetWorkRecv_UseGParam( int NetHandle,       void *Buffer, int Length, int Peek, int ASyncLoadFlag = FALSE ) ;		// NetWorkRecv ̃O[of[^ɃANZXȂo[W
extern	int			NetWorkSend_UseGParam( int NetHandle, const void *Buffer, int Length, int ASyncLoadFlag = FALSE ) ;					// NetWorkSend ̃O[of[^ɃANZXȂo[W
extern	int			MakeUDPSocketBase_UseGParam( int IsIPv6, int RecvPort, int ASyncLoadFlag = FALSE ) ;								// MakeUDPSocketBase ̃O[of[^ɃANZXȂo[W
extern	int			NetWorkSendUDP_UseGParam( int NetUDPHandle, IPDATA SendIP_IPv4, IPDATA_IPv6 SendIP_IPv6, int SendPort, const void *Buffer, int Length, int ASyncLoadFlag = FALSE ) ;	// NetWorkSendUDP ̃O[of[^ɃANZXȂo[W
extern	int			NetWorkRecvUDP_UseGParam( int NetUDPHandle, void *RecvIP, int *RecvPort, void *Buffer, int Length, int Peek, int ASyncLoadFlag = FALSE ) ;						// NetWorkRecvUDP ̃O[of[^ɃANZXȂo[W

#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // DX_NON_NETWORK

#endif // __DXNETWORK_H__
