// -------------------------------------------------------------------------------
// 
// 		cwCu		͏vOwb_t@C
// 
// 				Ver 3.13f
// 
// -------------------------------------------------------------------------------

#ifndef __DXINPUT_H__
#define __DXINPUT_H__

#include "DxCompileConfig.h"

#ifndef DX_NON_INPUT

// CN[h ------------------------------------------------------------------
#include "DxLib.h"
#include "DxStatic.h"
#include "DxDirectX.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

// [^[̔ԍ`
#define DINPUTPAD_MOTOR_LEFT		0
#define DINPUTPAD_MOTOR_RIGHT		1
#define DINPUTPAD_MOTOR_NUM			2

// \̒` --------------------------------------------------------------------

// pbh̐Ȕ
struct DINPUTPAD_EFFECT
{
	D_IDirectInputEffect	*DIEffect ;							// pbhfoCXGtFNgIuWFNg
	int						PlayFlag ;							// GtFNgĐAtO
	int						Power ;								// GtFNg̋
	int						Time ;								// GtFNg̒
	int						CompTime ;							// GtFNgJnĂo߂
	int						BackTime ;							// GtFNg̑O񒲂ׂ
	int						PlayState ;							// DirectInputEffect ̍Đ(\tgANeBuɂȂ΍Đ~)
	int						SetPower ;							// DirectInputEffect ̐ݒp[
} ;

// pbh̏
struct DINPUTPAD
{
	int						XInputDeviceNo ;					// XInputŃANZXfoCX̏ꍇ͂Oȏ̒l( DirectInput ňꍇ -1 )
	D_XINPUT_STATE			XInputState ;						// XInputł̃pbh̏

	D_IDirectInputDevice7	*Device ;							// pbhfoCXIuWFNg
//	D_IDirectInputEffect	*LeftEffect ;						// pbhfoCXGtFNgIuWFNg
//	D_IDirectInputEffect	*RightEffect ;						// pbhfoCXGtFNgIuWFNg
	HANDLE					Event ;								// pbh̃Cxgnh
	D_DIJOYSTATE			State ;								// 
	int						RightStickFlag ;					// EXeBbN邩ǂ
	int						GetTime ;							// 擾
//	int						EffectNotCommonFlag ;				// Ẽ[^[Ńp[^LȂǂ̃tO
//	DINPUTPAD_EFFECT		EffectCommon ;						// Ẽ[^[Ńp[^Lꍇ̏
	DINPUTPAD_EFFECT		Effect[ DINPUTPAD_MOTOR_NUM ] ;		// [^[̏
//	int						EffectPlayFlag ;					// GtFNgĐAtO
//	int						EffectPower ;						// GtFNg̋
//	int						EffectTime ;						// GtFNg̒
//	int						EffectCompTime ;					// GtFNgJnĂo߂
//	int						EffectBackTime ;					// GtFNg̑O񒲂ׂ
//	int						EffectPlayStateLeft ;				// DirectInputEffect ł́A̍Đ(\tgANeBuɂȂ΍Đ~)
//	int						EffectPlayStateRight ;				// DirectInputEffect ł́A̍Đ(\tgANeBuɂȂ΍Đ~)
	wchar_t					InstanceName[MAX_PATH];				// foCX̓o^
	wchar_t					ProductName[MAX_PATH];				// foCX̐io^
	DWORD					DeadZone ;							// ][( 65536 = 100% )
} ;

// chpf[^\̌^
struct DINPUTDATA
{
	HMODULE					XInputDLL ;							// wĥckk

	DWORD					( WINAPI * XInputGetStateFunc )( DWORD dwUserIndex, D_XINPUT_STATE* pState ) ;
	DWORD					( WINAPI * XInputSetStateFunc )( DWORD dwUserIndex, D_XINPUT_VIBRATION* pVibration ) ;

	int						NoUseXInputFlag ;					// whgpȂǂ̃tO
	int						NoUseDirectInputFlag ;				// chgpȂǂ̃tO
	int						NoUseVibrationFlag ;				// ch̐U@\gpȂǂ̃tO
	int						UseDirectInputFlag ;				// chgp邩ǂ̃tO( NoUseDirectInputFlag ⏕ )
	int						UseDirectInput8Flag ;				// chWgp邩ǂ̃tO
	D_IDirectInput7			*DirectInputObject ;				// chIuWFNg

	D_IDirectInputDevice7	*MouseDeviceObject ;				// }EXfoCXIuWFNg
	D_IDirectInputDevice7	*KeyboardDeviceObject ;				// L[{[hfoCXIuWFNg
	HANDLE					KeyEvent ;							// L[{[h̃Cxgnh
	int						KeyInputGetTime ;					// OɏԂ擾
	unsigned char			KeyInputBuf[256] ;					// L[{[h̓͏
	int						KeyExclusiveCooperativeLevelFlag ;	// L[{[h̋xrxɂȂĂ邩ǂtO
	int						KeyToJoypadInputInitializeFlag ;	// KeyToJoypadInput xłǂ̃tO
	int						KeyToJoypadInput[ MAX_JOYPAD_NUM ][ 32 ][ 4 ] ;	// WCpbh̓͂ɑΉL[{[h̓
	int						MouseInputBufValidFlag ;			// MouseInputBuf Lǂ( TRUE:L  FALSE: )
	BYTE					MouseInputBuf[ 4 ] ;				// }EX̓͏( 0:LEFT 1:RIGHT 2:MIDDLE )
	int						MouseMoveZ ;						// }EXzC[̈ړl

	int						JoyPadNum ;							// WCpbh̐
	DINPUTPAD				Joypad[ MAX_JOYPAD_NUM ] ;			// pbhfoCX

	int						KeyboardNotDirectInputFlag ;		// L[{[hfoCX̃ANZX DirectInput gpȂAtO
	int						EndFlag ;
	int						F10Flag ;							// F10 ꂽtO
	int						F10InputTime ;						// F10 ꂽ
	int						F12Flag ;							// F12 ꂽtO
	int						F12InputTime ;						// F12 ꂽ
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------------

// ch̏AI֐
extern	int InitializeDirectInput( void ) ;											// ch 
extern	int TerminateDirectInput( void ) ;											// ch̎gpI

extern	int SetF10Input( void ) ;													// F10 ꂽƂɂtO𗧂Ă
extern	int ResetF10Input( void ) ;													// F10 ꂽƂɂtO𗧂Ă
extern	int SetF12Input( void ) ;													// F12 ꂽƂɂtO𗧂Ă
extern	int ResetF12Input( void ) ;													// F12 ꂽƂɂtO𗧂Ă
extern	int RefreshInputDeviceAcquireState( void ) ;								// chfoCX̎擾ԂXV
extern	int JoypadEffectProcess( void ) ;											// pbhGtFNgɊւt[s
extern	int RefreshEffectPlayState( void ) ;										// pbhGtFNg̍ĐԂXV(\tgANeBuɂȂ邱Ƃ邽)
extern	int UpdateKeyboardInputState( int UseProcessMessage = TRUE ) ;				// ͏Ԃ̍XV
extern	int SetupJoypad( void ) ;													// WCpbh̃ZbgAbvs
extern	int TerminateJoypad( void ) ;												// WCpbȟns
extern	int CheckUseDirectInputMouse( void ) ;										// }EX̏擾ɂchgpĂ邩ǂ擾( ߂l  TRUE:DirectInputgpĂ  FALSE:DirectInputgpĂȂ )
extern	int GetDirectInputMouseMoveZ( int CounterReset = TRUE ) ;					// chgp}EXzC[̈ړl擾
extern	float GetDirectInputMouseMoveZF( int CounterReset = TRUE ) ;				// chgp}EXzC[̈ړl擾( float )

// wchar_tŊ֐
extern int GetJoypadName_WCHAR_T( int InputType, wchar_t *InstanceNameBuffer, wchar_t *ProductNameBuffer ) ;


#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // DX_NON_INPUT

#endif // __DXINPUT_H__
